it-swarm.com.de

nicht in gzip komprimieren im webpack

ich möchte meine reakt-app in gzip komprimieren, eigentlich ist es 2,2 mb, also habe ich compression-webpack-plugin verwendet, aber ich kann nicht komprimieren
Mein webpack.config.js

const webpack = require('webpack');
const path = require('path');
const fs = require("fs")
const ExtractTextPlugin = require('extract-text-webpack-plugin');
const HtmlWebpackPlugin = require('html-webpack-plugin');
const BundleAnalyzerPlugin = require('webpack-bundle-analyzer').BundleAnalyzerPlugin;
const CompressionPlugin = require('compression-webpack-plugin');

const VENDOR_LIBS =[
    'antd','axios','moment','rc-time-picker','react',
    'react-dom','react-ga','react-google-maps','react-loadable',
    'react-redux','react-router','react-router-dom','recompose','redux','redux-thunk'
]
module.exports = (env) => {
    const isProduction = env === 'production';
    const CSSExtract = new ExtractTextPlugin('styles.css');

    return {
        node: {
            fs: 'empty',
            child_process: 'empty',
          },
        entry: {
            bundle:'./src/app.js',
            vendor:VENDOR_LIBS
        },
        output: {
            path: path.join(__dirname, 'public'),
            filename: '[name].js'
        },
        module: {
            rules: [{
                loader: 'babel-loader',
                test: /\.js$/,
                exclude: /node_modules/
            }, {
                test: /\.s?css$/,
                use: CSSExtract.extract({
                    use: [
                        {
                            loader: 'css-loader',
                            options: {
                                sourceMap: true
                            }
                        },
                        {
                            loader: 'sass-loader',
                            options: {
                                sourceMap: true
                            }
                        }
                    ]
                })
            },{
                test: /\.(gif|svg|jpg|png|ttf|eot|woff(2)?)(\?[a-z0-9=&.]+)?$/,
                loader: "file-loader",
            }],
        },

        plugins: [
            CSSExtract,
            new webpack.optimize.CommonsChunkPlugin({
                name:'vendor'
            }),
            new HtmlWebpackPlugin({
                template:'src/index.html'
            }),
            new CompressionPlugin(),
            new BundleAnalyzerPlugin()

        ],
        devtool: isProduction ? 'source-map' : 'inline-source-map',
        devServer: {
            contentBase: path.join(__dirname, 'public'),
            historyApiFallback: true,
            Host:'0.0.0.0',
            disableHostCheck: true,
        }
    };
};

es zeigt mir Fehler

TypeError: Eigenschaft 'emit' von undefined kann nicht gelesen werden
bei CompressionPlugin.apply (/ media/.........
wenn ich dem CompressionPlugin weitere Optionen hinzufügen möchte 

new CompressionPlugin({
  asset: '[path].gz[query]',
  algorithm: 'gzip',
  test: /\.js$|\.css$|\.html$|\.eot?.+$|\.ttf?.+$|\.woff?.+$|\.svg?.+$/,
  threshold: 10240,
  minRatio: 0.8
  })

es zeigt mir Fehler 

neuen validationError werfen (ajv.errors, name); 
ValidationError: Ungültige Optionen für das Komprimierungs-Plugin 
Optionen sollten KEINE zusätzlichen Eigenschaften haben 

wie kann ich dieses Problem lösen? Gibt es eine andere Möglichkeit, meine App zu kopieren?.

3

Ändern Sie "Asset" in "Dateiname".

new CompressionPlugin({
  filename: '[path].gz[query]',
  algorithm: 'gzip',
  test: /\.js$|\.css$|\.html$|\.eot?.+$|\.ttf?.+$|\.woff?.+$|\.svg?.+$/,
  threshold: 10240,
  minRatio: 0.8
})
13
Cyro Farias

Ihr Problem ist, dass Sie mit Webpack 4 arbeiten müssen und der Knoten> 6.9.0 sein muss, wie in den Dokumenten angegeben:

"Dieses Modul erfordert mindestens Node v6.9.0 und Webpack v4.0.0."

Ihre Konfiguration ist auch falsch:

new CompressionPlugin({
  filename: '[path].gz[query]',
  algorithm: 'gzip',
  test: /\.js$|\.css$|\.html$|\.eot?.+$|\.ttf?.+$|\.woff?.+$|\.svg?.+$/,
  threshold: 10240,
  minRatio: 0.8
})
1
PlayMa256

[email protected] hat brechende Änderungen.

Sie müssen entweder ein Upgrade auf Webpack 4 durchführen oder die [email protected] verwenden.

Und auch die Asset-Option ist veraltet, verwenden Sie stattdessen filename .

0
ADIL